package com.mugil.org.services;

import com.mugil.org.models.Employee;
import com.mugil.org.repository.EmployeeDB;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PatchMapping;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Predicate;

@Service
public class EmpServiceImpl implements EmpService {

    @Autowired
    EmployeeDB employeeDB;

    List<Employee> arrEmployee = new ArrayList<>();

    public EmpServiceImpl(){
        arrEmployee.add(new Employee("101", "Mugil"));
    }

    public List addEmployeeList(Employee employee)
    {
        employeeDB.addEmployeetoDB(employee);
        return employeeDB.getEmployeesFromDB();
    }

    @Override
    public String updateEmpDetails(Employee emp, String pEmpId) {
        if(employeeDB.updateEmployeeInDB(emp, pEmpId))
            return "Updated Successfully";
        else
            return "Updation Failed";
    }

    @Override
    public List getEmployees() {
        return arrEmployee;
    }

    public Employee getEmployeeById(String pEmpId)
    {
        return employeeDB.getEmployeeByIdFromDB(pEmpId);
    }

    public String deleteEmployeeById(String pEmpId)
    {
        if(employeeDB.deleteEmployeeByIdFromDB(pEmpId))
            return "Deleted Successfully";
        else
            return "Deletion Failed";
    }
}
